
// auswertung.h
// LFTVideo.cpp  v1.72
//               9.6.2003
// 
// fr weitere Informationen:
// siehe header von main.cpp

#ifndef AUSWERTUNG_H
#define AUSWERTUNG_H

#include <qarray.h>
#include "zeitverlauf.h"

#include "lftvideoanalysedialog.h"
// class LFTVideoAnalyseDialog; // forward declaration, damit hier bekannt
                             // siehe "lftvideoanalysedialog.h"
	                         // zyklische Abhngigkeit (leider)
				
 
class AnzahlDauer {
public:
	AnzahlDauer (int a=0, float d=0) : Anzahl(a), Dauer(d) {};
	long Anzahl;
	double Dauer;
};


class VerlaufsAuswertung {
public:
	RatingVerlauf *Verlauf;
	QArray<AnzahlDauer > SummenTabelle;
	long uew[8][8];				// 2dim array fr bergangswahrscheinlichkeiten
	long uew2[8][8][8];			// 3dim array fr bergangswahrscheinlichkeiten 3.Ordn
	long AnzahlTherapeut;
	long AnzahlKlient;
	double DauerTherapeut;
	double DauerKlient;
	double AnteilTherapeutAnzahl, AnteilTherapeutDauer; // Dateiwerte 1&2
	double AnteilKlientAnzahl, AnteilKlientDauer;		// Dateiwerte 3&4
	double LoesfokUnteranzahlTherapeut, LoesfokUnterdauerTherapeut;// 5&6
	double LoesfokUnteranzahlKlient, LoesfokUnterdauerKlient;      // 7&8
	double PassungAnzahl, PassungDauer;					// Dateiwerte 9,10

	double AufnahmeLoesFok, verspaetAufnahmeLoesFok;	// Dateiwerte 11, 12
	double TherapNLAnpassung, TherapFrustration;		// Dateiwerte 13, 14

	void DatenAnalysieren(RatingVerlauf* derVerlauf) ;
	void DatenAnzeigen(LFTVideoAnalyseDialog* diag) ;

	double GesamtDauer() {return Verlauf->BisherLetzterMoment().toSecs();};
	int GesamtAnzahl() // -1 wegen Sinneinheit 00:00.000
		 {return Verlauf->Sinneinheiten.size() -1 ;};
	double Durchschnittsdauer() 
		{return GesamtDauer() / GesamtAnzahl() ;};

	double DurchschnittsdauerTherapeut()
		{return DauerTherapeut / AnzahlTherapeut ;};
	double DurchschnittsdauerKlient()
		{return DauerKlient / AnzahlKlient ;};
};


#endif // AUSWERTUNG_H