// datenspeichern.cpp
// LFTVideo.cpp  v1.7
//               12.5.2003
// 
// fr weitere Informationen:
// siehe header von main.cpp

#include "datenspeichern.h"

#include <qmessagebox.h>
#include <qfile.h>
#include <qdatetime.h>

int DatenSpeichern::DateiFehler(QString filename, QString vorgang, QString was){
      
	QString text="Konnte die Daten nicht "+vorgang+".\n\n"
				+filename+"\n" +was+
				"\n\nNoch mal versuchen?";

    switch( QMessageBox::warning( this, "LFTVideo Festplattenzugriff?",	text,
                                  QMessageBox::Retry | QMessageBox::Default,
                                  QMessageBox::Abort | QMessageBox::Escape )) {
    case QMessageBox::Retry: // Retry or Enter
			return 1;
        break;
    case QMessageBox::Abort: // Abort or Cancel
			return 0;
        break;
	default:
			return -1;
		break;
    }
};

bool DatenSpeichern::speichereDaten(QString filename, QString was){

	QFile f( filename );

	AnfangSpeicherRoutine:
	int Antwort=0;

	f.open( IO_WriteOnly );
	if(f.status()!=IO_Ok) {
		qDebug("ERROR opening file "+filename); 
		Antwort=DateiFehler(filename,
			"speichern","("+was+" - Datei nicht zu FFNEN)");
		f.close();
		if (Antwort<=0) return false;
		 else goto AnfangSpeicherRoutine;
	}

    QTextStream s( &f );
	DatenSpeicherStream(s);
	
	Antwort=0;
	f.close();
	if(f.status()!=IO_Ok) {
		qDebug("ERROR saving or closing file "+filename); 
		Antwort=DateiFehler(filename,
			"speichern","("+was+" - Datei nicht zu SCHLIESSEN)");
		f.close();
		if (Antwort<=0) return false;
		  else goto AnfangSpeicherRoutine;
	}	  

	return true;
};


bool DatenSpeichern::leseDaten(QString filename, QString was){

	QFile f( filename );

	AnfangLeseRoutine:
	int Antwort=0;

	f.open( IO_ReadOnly );
	if(f.status()!=IO_Ok) {
		qDebug("ERROR opening file "+filename); 
		Antwort=DateiFehler(filename,
			"lesen","("+was+" - Datei nicht zu FFNEN)");
		f.close();
		if (Antwort<=0) return false;
		 else goto AnfangLeseRoutine;
	}
		
    QTextStream s( &f );
	DatenLeseStream(s);
	
	Antwort=0;
	f.close();

	if(f.status()!=IO_Ok) {
		qDebug("ERROR reading or closing file "+filename); 
		Antwort=DateiFehler(filename,
			"lesen","("+was+" - Datei nicht zu SCHLIESSEN)");
		f.close();
		if (Antwort<=0) return false;
		  else goto AnfangLeseRoutine;
	}	  

	return true;
};


// class VerlaufSpeichern 
/////////////////////////

QString VerlaufSpeichern::gibFilename(QString Klient, QString Rater){
	derKlient=Klient;
	derRater=Rater;

	QString temp;
	temp=Klient;
	temp+="_";
	temp+=Rater;
	temp+= "_Verlauf.dat";
	return temp;
}

/*
// alt: Ist nach class RatingVerlauf migriert
bool VerlaufSpeichern::DatenSpeicherStream (QTextStream &s) {
	qDebug("overridden virtual");
	MinSec Zeitpunkt=MinSec(0,0), ZeitpunktDavor=MinSec(0,0);
	RatingSkala Einsch=null, EinschDavor=null;
	double Dauer=0;
	MinSec2Rating::iterator it;
	it = ptrVerlauf->Sinneinheiten.begin();

    for ( ; it!= ptrVerlauf->Sinneinheiten.end(); ++it){
		ZeitpunktDavor=Zeitpunkt;
		Zeitpunkt=it->first;
		Dauer=(Zeitpunkt - ZeitpunktDavor).toSecs(); 

		EinschDavor=Einsch;
		Einsch=it->second;

		s << Zeitpunkt.toQString() << '\t';
		s << Einsch << '\t';
		s << EinschDavor << '\t';
		s << Dauer << '\t';
		s << derKlient << '\t';
		s << derRater << '\n';
	}	
	return true;
}

*/

bool VerlaufSpeichern::DatenSpeicherStream (QTextStream &s) {
	qDebug("overridden virtual");
	bool ok=ptrVerlauf->speichereGesamtenRatingVerlauf (s, derKlient, derRater);
	qDebug("VerlaufSpeichern::DatenSpeicherStream erfolgreich? %d",ok);
	return ok;
}


bool VerlaufSpeichern::DatenLeseStream (QTextStream &s) {
	qDebug("overridden virtual");
	bool ok=ptrVerlauf->liesGesamtenRatingVerlauf (s);
	qDebug("VerlaufSpeichern::DatenLeseStream erfolgreich? %d",ok);
	return ok;
}


// class InfoSpeichern 
/////////////////////////

void InfoSpeichern::merkDirDaten (QString anzahlTastendruecke, 
								  QString mittlereSinneinheitenDauer,
								  MinSec gesamtdauer,
								  bool weitergefuehrteSession,
								  bool PauseGedrueckt){
	anzGedrTasten = anzahlTastendruecke;
	mittlereDauer = mittlereSinneinheitenDauer;
	Gesamtdauer = gesamtdauer;
	weitergefSession = weitergefuehrteSession;
	GedrPause = PauseGedrueckt;
};

QString InfoSpeichern::gibFilename(QString Klient, QString Rater){
	derKlient=Klient;
	derRater=Rater;

	QString temp;
	temp=Klient;
	temp+="_";
	temp+=Rater;
	temp+= "_Info.dat";
	return temp;
};

bool InfoSpeichern::DatenSpeicherStream (QTextStream &s) {
	qDebug("overridden virtual");
	s << "Klient:\t"<<derKlient<<'\n';
	s << "Rater:\t"<<derRater<<'\n';
	s << "Datum:\t"<<QDate::currentDate().toString()<<'\n';
	s << "Zeit:\t"<<QTime::currentTime().toString()<<'\n';
	s << "letzte Sinneinheit bei:\t"<<Gesamtdauer.toQString()<<'\n';
	s << "Anzahl Sinneinheiten:\t"<<anzGedrTasten<<'\n';
	s << "Dauer mittlerer Sinneinheit:\t"<<mittlereDauer<<'\n';
	QString temp=weitergefSession?"ja":"nein";
	s << "Weitergefuehrte Session:\t"<<temp<<'\n';
	temp=GedrPause?"ja":"nein";
	s << "Pause gedrckt:\t"<<temp<<'\n';
	
	return true;
};

bool InfoSpeichern::DatenLeseStream (QTextStream &s) {
	qDebug("overridden virtual, aber nicht implementiert, "
		   "weil nicht gebraucht!");
	return false;
};




// class AuswertungSpeichern 
////////////////////////////

void AuswertungSpeichern::merkDirDaten (VerlaufsAuswertung* dieAuswertung,
										QString dieEndung){
	Auswertung=dieAuswertung;
	Endung=dieEndung;
};

QString AuswertungSpeichern::gibFilename(QString Klient, QString Rater){
	derKlient=Klient;
	derRater=Rater;

	QString temp;
	temp=Klient;
	temp+="_";
	temp+=Rater;
	temp+= "_";
	temp+=Endung;
	temp+=".dat";
	return temp;
};

bool AuswertungSpeichern::DatenSpeicherStream (QTextStream &s) {
	qDebug("overridden virtual");
	s << Auswertung->AnteilTherapeutAnzahl << '\t';  // 1
	s << Auswertung->AnteilTherapeutDauer  << '\t';  // 2
	s << Auswertung->AnteilKlientAnzahl	  << '\t';  // 3
	s << Auswertung->AnteilKlientDauer	  << '\t';  // 4
	s << Auswertung->LoesfokUnteranzahlTherapeut << '\t'; // 5
	s << Auswertung->LoesfokUnterdauerTherapeut  << '\t'; // 6
	s << Auswertung->LoesfokUnteranzahlKlient    << '\t'; // 7
	s << Auswertung->LoesfokUnterdauerKlient     << '\t'; // 8
	s << Auswertung->PassungAnzahl << '\t';  // 9
	s << Auswertung->PassungDauer  << '\t';  // 10
	s << Auswertung->AufnahmeLoesFok << '\t'; // 11
	s << Auswertung->verspaetAufnahmeLoesFok << '\t'; //12
	s << Auswertung->TherapNLAnpassung << '\t'; //13
	s << Auswertung->TherapFrustration << '\t'; //14
	s << derKlient << '\t'; //15
	s << derRater << '\n'; //16

	return true;
};

bool AuswertungSpeichern::DatenLeseStream (QTextStream &s) {
	qDebug("overridden virtual, aber nicht implementiert, "
		   "weil nicht gebraucht!");
	return false;
};




// class QStringSpeichern 
/////////////////////////

void QStringSpeichern::merkDirDaten (QString derGanzeString, QString DateiEndung){
	alleDaten=derGanzeString;
	Endung=DateiEndung;
};

QString QStringSpeichern::gibFilename(QString Klient, QString Rater){
	derKlient=Klient;
	derRater=Rater;

	QString temp;
	temp=Klient;
	temp+="_";
	temp+=Rater;
	temp+= "_";
	temp+=Endung;
	temp+=".dat";
	return temp;
};

bool QStringSpeichern::DatenSpeicherStream (QTextStream &s) {
	qDebug("overridden virtual");
	s << alleDaten;
	
	return true;
};

bool QStringSpeichern::DatenLeseStream (QTextStream &s) {
	qDebug("overridden virtual, aber nicht implementiert, "
		   "weil nicht gebraucht!");
	return false;
};

