
// datenspeichern.h
// LFTVideo.cpp  v1.7
//               12.5.2003
// 
// fr weitere Informationen:
// siehe header von main.cpp

#ifndef DATENSPEICHERN_H
#define DATENSPEICHERN_H

#include "zeitverlauf.h"
#include "auswertung.h"
#include <qtextstream.h>
#include <qstring.h>
#include <qwidget.h>

class DatenSpeichern : public QWidget {
	Q_OBJECT
protected:
	QString derKlient;
	QString derRater;
public:
	DatenSpeichern( QWidget* parent = 0, 
		            const char* name = 0, bool modal = FALSE)
		         : QWidget( parent, name, modal) {};

	bool speichereDaten(QString filename, QString was);
	bool leseDaten(QString filename, QString was);
public:
	virtual bool DatenSpeicherStream (QTextStream &s) 
		{qDebug("virtual"); return true;};
	virtual bool DatenLeseStream (QTextStream &s)     
		{qDebug("virtual"); return true;};
	virtual QString gibFilename(QString Klient, QString Rater) 
		{qDebug("virtual"); return "";};
protected:
	int DateiFehler(QString filename, QString vorgang, QString was);
};


// class VerlaufSpeichern : public DatenSpeichern
/////////////////////////////////////////////////

class VerlaufSpeichern : public DatenSpeichern {
private:
	RatingVerlauf* ptrVerlauf;
public:
	VerlaufSpeichern( QWidget* parent = 0, 
					  const char* name = 0, bool modal = FALSE)
				  : DatenSpeichern ( parent, name, modal) {};
	void setzePointerAufDaten(RatingVerlauf* pointer) {ptrVerlauf=pointer;};
	bool DatenSpeicherStream (QTextStream &s) ;
	bool DatenLeseStream (QTextStream &s) ;
	QString gibFilename(QString Klient, QString Rater);
};


// class InfoSpeichern : public DatenSpeichern
//////////////////////////////////////////////

class InfoSpeichern : public DatenSpeichern {
private:
	QString anzGedrTasten;
	QString mittlereDauer;
	MinSec Gesamtdauer;
	bool weitergefSession;
	bool GedrPause;
public:
	InfoSpeichern( QWidget* parent = 0, 
		           const char* name = 0, bool modal = FALSE)
			   : DatenSpeichern ( parent, name, modal) {};
	bool DatenSpeicherStream (QTextStream &s) ;
	bool DatenLeseStream (QTextStream &s) ;
	void merkDirDaten (QString anzahlTastendruecke, 
					   QString mittlereSinneinheitenDauer,
					   MinSec Gesamtdauer,
					   bool weitergefuehrteSession,
					   bool PauseGedrueckt);
	    // Klient und Rater werden durch gibFilename geSETZT!
	QString gibFilename(QString Klient, QString Rater);
	
};


// class AuswertungSpeichern : public DatenSpeichern
////////////////////////////////////////////////////

class AuswertungSpeichern : public DatenSpeichern {
private:
	QString Endung;
	VerlaufsAuswertung* Auswertung;
public:
	AuswertungSpeichern( QWidget* parent = 0, 
						 const char* name = 0, bool modal = FALSE)
			             : DatenSpeichern ( parent, name, modal) {};
	// Hier sollen alle Daten drin sein
	void merkDirDaten (VerlaufsAuswertung* dieAuswertung, QString dieEndung);
	bool DatenSpeicherStream (QTextStream &s) ;
	bool DatenLeseStream (QTextStream &s) ;
	    // Klient und Rater werden durch gibFilename geSETZT!
	QString gibFilename(QString Klient, QString Rater);
};

// class QStringSpeichern : public DatenSpeichern
/////////////////////////////////////////////////

class QStringSpeichern : public DatenSpeichern {
private:
	QString alleDaten;
	QString Endung;
public:
	QStringSpeichern( QWidget* parent = 0, 
		              const char* name = 0, bool modal = FALSE)
			          : DatenSpeichern ( parent, name, modal) {};
	// Hier sollen alle Daten drin sein
	void merkDirDaten (QString derGanzeString, QString DateiEndung);
	bool DatenSpeicherStream (QTextStream &s) ;
	bool DatenLeseStream (QTextStream &s) ;
	    // Klient und Rater werden durch gibFilename geSETZT!
	QString gibFilename(QString Klient, QString Rater);
};


#endif // DATENSPEICHERN_H