// lftvideodialog.h
// LFTVideo.cpp  v1.7
//               12.5.2003
// 
// fr weitere Informationen:
// siehe header von main.cpp


#include "lftvideodialogbase.h"
#include "sitzungskonfigurationdialog.h"
#include "zeitverlauf.h"
#include "datenspeichern.h"

#include <qdatetime.h>
#include <qtimer.h>

// helper:
QString giveDateStamp ();
QString giveTimeStamp ();

class LFTVideoDialog : public LFTVideoDialogBase
{
	Q_OBJECT
public:
	LFTVideoDialog( QWidget* parent = 0, 
					const char* name = 0, bool modal = FALSE, WFlags f = 0 );
	~LFTVideoDialog();
	SitzungsKonfigurationDialog *KonfigDialog;
    QTime *zaehlwerk;

	void initNullSetzungen();		// Neubeginn von Verlauf und GUI
	double vergangeneZeitInSekunden();
	double vergangeneSekunden();
	int vergangeneMinuten();

private:
	bool weitergefuehrteSession;  // tauchen in _info.dat auf, denn das macht
	bool PauseGedrueckt;          // macht nmlich inter-Rater-Vergleiche schwerer!
	MinSec letzterEinschaetzungsZeitpunkt;
	RatingVerlauf *Verlauf;
	QTimer *SekundenTimer;
	QTimer *CountdownTimer;
	int StartLCDSekunden, StartLCDMinuten; 
	// N.B.: int, d.h. Millisekunden werden nur im laufenden Timer gehalten!

	int falscherButton; //fr Korrekturen

public slots:
	void openKonfigDialog();
	
private slots:
	void RatingBeginnOderPause(bool beginn);
	void aktualisiereZeitanzeige();
	void SpeichereRatingButton(int BtNumber);
	void RatingEnde();
	void KorrigierenSchalter(bool toggled);
	void SliderCheckFaerbung();
	void CountdownStart(bool);
	void Countdown();
};

